import { SKIP, visit } from "estree-util-visit";
export function moveChildrenToHikeProp(node) {
    const childrenByPath = {};
    node.children.forEach((slot) => {
        const path = slot.openingElement.attributes.find((a) => a.name.name === "path").value.value;
        childrenByPath[path] = childrenByPath[path] || [];
        childrenByPath[path].push(slot.children);
    });
    const hikeAttribute = node.openingElement.attributes.find((a) => a.name.name === "__hike");
    visit(hikeAttribute, function (node) {
        var _a;
        if ((node === null || node === void 0 ? void 0 : node.type) === "Property" && ((_a = node === null || node === void 0 ? void 0 : node.key) === null || _a === void 0 ? void 0 : _a.value) === "children") {
            const path = node.value.value;
            // console.log("visit", path)
            const elements = childrenByPath[path].shift();
            node.value = {
                type: "ArrayExpression",
                elements,
            };
            return SKIP;
        }
    });
    node.children = [];
    hikeAttribute.name.name = "hike";
}
