import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from "react";
import { CodeContent } from "./code-content.js";
export { CodeContent };
export async function Code({ codeblocks, config, components, as, ...rest }) {
    if (as) {
        return React.createElement(as, {
            codeblocks,
            config,
            components,
            ...rest,
        });
    }
    return (_jsx("div", { children: codeblocks.map((codeblock, i) => (
        // @ts-expect-error
        _jsx(SingleCode, { codeblock: codeblock, config: config, components: components }, i))) }));
}
async function SingleCode({ codeblock, config, components, }) {
    const { lang, meta, value, annotations } = codeblock;
    return (_jsxs("div", { style: {
            border: "1px solid black",
            borderRadius: "4px",
            margin: 8,
            padding: 8,
        }, "data-ch-theme": config.themeName, children: [_jsx("div", { children: meta }), _jsx(CodeContent, { codeblock: codeblock, config: config, components: components, "data-ch-lang": lang })] }));
}
