/// <reference types="react" />
import { Annotation, Theme } from "@code-hike/lighter";
export type FinalToken = [string, string?, React.CSSProperties?];
export type Whitespace = string;
export type Group = [[string, string?, {
    inline: true;
}?], AnyToken[]];
export type AnyToken = FinalToken | Group | Whitespace;
export declare function isFinalToken(token: AnyToken): token is FinalToken;
export declare function isGroup(token: AnyToken): token is Group;
export declare function isWhitespace(token: AnyToken): token is Whitespace;
export type FinalConfig = {
    theme: Theme;
    themeName: string;
    annotationPrefix: string;
};
export type CodeBlock = {
    lang?: string;
    meta?: string;
    value: string;
    annotations?: Annotation[];
    parentPath?: string;
};
//# sourceMappingURL=types.d.ts.map