"use client";
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import React from "react";
export function DebugHike({ hike }) {
    const tree = React.useMemo(() => hikeToTree(hike, "", "hike"), [hike]);
    const [selected, setSelected] = React.useState(tree);
    return (_jsxs("div", { className: "not-prose", style: {
            border: "1px solid #67e8f9",
            borderRadius: 6,
            margin: "8px auto",
            display: "flex",
            flexDirection: "column",
            backgroundColor: "#082f49",
            overflow: "hidden",
            maxWidth: 960,
            maxHeight: 800,
            minHeight: 400,
        }, children: [_jsxs("div", { style: {
                    textAlign: "center",
                    color: "black",
                    fontSize: 14,
                    padding: "4px 0px",
                    background: "#67e8f9",
                }, children: [_jsx("code", { children: `<Hike />` }), " debug view"] }), _jsxs("div", { style: { display: "flex", overflow: "hidden", flex: 1 }, children: [_jsx("div", { style: { flex: 1, minWidth: 0, padding: 0, overflowY: "auto" }, children: _jsx(Node, { node: hikeToTree(hike, "", "hike"), setSelected: setSelected, selected: selected }) }), _jsxs("div", { style: {
                            flex: 1,
                            minWidth: 0,
                            padding: 4,
                            backgroundColor: "white",
                            color: "#082f49",
                            overflowY: "auto",
                            minHeight: "100%",
                        }, children: [_jsx(Property, { name: "path", children: selected.path }), _jsx("hr", {}), selected === null || selected === void 0 ? void 0 : selected.content] })] })] }));
}
function Property({ name, children }) {
    return (_jsxs("div", { style: { display: "flex", gap: 8, margin: "4px 0" }, children: [_jsx("pre", { style: {
                    width: 100,
                    minWidth: 100,
                    textAlign: "right",
                }, children: name }), _jsx("span", { style: { background: "#e0f2fe", padding: "0px 4px", borderRadius: 4 }, children: children })] }));
}
const padding = 16;
function Node({ node, setSelected, selected, level = 1 }) {
    const { name, children } = node;
    const [hover, setHover] = React.useState(false);
    const isSelected = (selected === null || selected === void 0 ? void 0 : selected.path) == node.path;
    return (_jsxs(_Fragment, { children: [_jsx("pre", { onClick: () => setSelected(node), onMouseEnter: () => setHover(true), onMouseLeave: () => setHover(false), style: {
                    paddingLeft: padding * level,
                    cursor: "pointer",
                    backgroundColor: isSelected
                        ? "#0a6fa6"
                        : hover
                            ? "#0c4a6e"
                            : "transparent",
                    textOverflow: "ellipsis",
                    whiteSpace: "nowrap",
                    overflow: "hidden",
                    color: "white",
                }, children: name }), _jsx("div", { style: { paddingLeft: 0 }, children: children.map((child, i) => (_jsx(Node, { node: child, setSelected: setSelected, selected: selected, level: level + 1 }, i))) })] }));
}
function hikeToTree(section, path, name) {
    const { query, children, code = [], ...rest } = section;
    const nodePath = path ? path + "." + name : name;
    const kids = codeToChildren(code, nodePath);
    Object.keys(rest).forEach((key, i) => {
        kids.push(listToTree(rest[key], nodePath, key));
    });
    return {
        path: nodePath,
        name: name,
        children: kids,
        content: (_jsxs(_Fragment, { children: [_jsx(Property, { name: "query", children: _jsx("pre", { children: query }) }), _jsx(Property, { name: "children", children: children }), kids.map((kid, i) => (_jsx(Property, { name: kid.name, children: _jsx("pre", { children: `[${kid.children.length} items]` }) }, i)))] })),
    };
}
function sectionToTree(section, path, name) {
    const { query, children, code = [], ...rest } = section;
    const nodePath = path;
    const kids = codeToChildren(code, nodePath);
    Object.keys(rest).forEach((key, i) => {
        kids.push(listToTree(rest[key], nodePath, key));
    });
    return {
        path: nodePath,
        name: name,
        children: kids,
        content: (_jsxs(_Fragment, { children: [_jsx(Property, { name: "query", children: query }), _jsx(Property, { name: "children", children: children }), kids.map((kid, i) => (_jsx(Property, { name: kid.name, children: _jsx("pre", { children: `[${kid.children.length} items]` }) }, i)))] })),
    };
}
function codeToChildren(codeblocks, path) {
    if (!codeblocks || codeblocks.length === 0)
        return [];
    const kids = codeblocks.map((code, i) => ({
        path: `${path}.code[${i}]`,
        name: `${i}: ${code.lang} ${typeof code.meta === "string" ? code.meta : ""}`,
        children: [],
        content: (_jsxs(_Fragment, { children: [_jsx(Property, { name: "lang", children: _jsx("pre", { children: code.lang }) }), _jsx(Property, { name: "meta", children: _jsx("pre", { children: typeof code.meta === "string" ? code.meta : "" }) }), _jsx(Property, { name: "value", children: _jsx("pre", { children: code.value }) })] })),
    }));
    return [
        {
            path: path + ".code",
            name: "code",
            children: kids,
            content: (_jsx(_Fragment, { children: codeblocks.map((code, i) => (_jsx(Property, { name: `[${i}]`, children: _jsx("pre", { children: `${code.lang} ${typeof code.meta === "string" ? code.meta : ""}` }) }, i))) })),
        },
    ];
}
function listToTree(list, path, name) {
    const nodePath = path ? path + "." + name : name;
    return {
        path: nodePath,
        name: name,
        children: list.map((item, i) => sectionToTree(item, `${nodePath}[${i}]`, `${i}: ${item.query}`)),
        content: (_jsx(_Fragment, { children: list.map((item, i) => (_jsx(Property, { name: `[${i}]`, children: `!${name} ${item.query}` }, i))) })),
    };
}
